<template>
  <div class="i-progress-bar" :style="rootStyle" :class="{ 'i-progress-bar--gray-background': grayBackground }">
    <div class="i-progress-bar__filled" :style="filledStyle" />
    <div v-if="textLeft" class="i-progress-bar__text i-progress-bar__text--left">{{ textLeft }}</div>
    <div v-if="textCenter" class="i-progress-bar__text i-progress-bar__text--center">{{ textCenter }}</div>
    <div v-if="textRight" class="i-progress-bar__text i-progress-bar__text--right">{{ textRight }}</div>
  </div>
</template>

<script>
  export default {
    props: {
      percentage: {
        type: Number,
        default: 70,
      },

      delay: {
        type: Number,
        default: 250,
      },

      height: {
        type: Number,
        default: 15,
      },

      textLeft: String,
      textCenter: String,
      textRight: String,
      grayBackground: Boolean,
    },

    computed: {
      rootStyle() {
        return {
          'height': `calc(${this.height}px * var(--scale))`,
          'border-radius': `calc(${this.height / 2}px * var(--scale))`,
        };
      },

      filledStyle() {
        return {
          'width': `${this.percentage}%`,
          'height': `calc(${this.height}px * var(--scale))`,
          'transition': `width ${this.delay}ms linear`,
          'padding-left': `calc(${this.height}px * var(--scale))`,
          'transform': `translateX(calc(${-this.height}px * var(--scale)))`,
          'border-radius': `calc(${this.height / 2}px * var(--scale))`,
        };
      },
    },
  };
</script>

<style lang="scss">
  .i-progress-bar {
    position: relative;
    width: 100%;
    height: rs(15px);
    border-radius: rs(math.div(15px, 2));
    background-color: #fdb5b6;
    overflow: hidden;

    &--gray-background {
      background-color: #f4f2f1;
    }
  }

  .i-progress-bar__filled {
    height: rs(15px);
    padding-left: rs(15px);
    box-sizing: content-box;
    transform: translateX(rs(-15px));
    border-radius: rs(math.div(15px, 2));
    background: linear-gradient(90deg, #ffb15e 0%, #fc5c95 110.73%);
  }

  .i-progress-bar__text {
    display: flex;
    align-items: center;
    position: absolute;
    z-index: 1;
    top: 0;
    height: 100%;
    font-size: rs(12px);
    color: #524c62;

    &--left {
      left: 10px;
      text-align: left;
    }

    &--center {
      left: 50%;
      transform: translateX(-50%);
      text-align: center;
    }

    &--right {
      right: 10px;
      text-align: right;
    }
  }
</style>
